
{-----------------------------------------------------------------------------|
| COMBINE.PAS  -  combine RMS records for group treatment by GREP, etc  |
|  |
| To be used with DCL Procedure PIPE.COM.                (Author: T.HALL)  |
|  |
|-----------------------------------------------------------------------------}

PROGRAM combine (input, output);

CONST string_length = 984; { Length chosen because of TPU }

TYPE  line_type = VARYING [string_length] OF char;

%INCLUDE 'parm.def'      { Allows to get next parameter with proc. NEXT_PARM }

VAR   line, parm, new_line : line_type;
      to_combine, i : integer;

BEGIN {program combine}
   next_parm (parm);
   IF parm = '' THEN 
      writeln ('*** COMBINE: Missing Parameter: How many lines to combine')
   ELSE 
   BEGIN
      readv (parm, to_combine);
      WHILE NOT eof DO
      BEGIN
         new_line := '';
         FOR i := 1 TO to_combine DO
         BEGIN
            IF NOT eof THEN
            BEGIN
               readln (line);
               new_line :=  new_line + line + ' ';
            END {if}
         END {for};
         IF new_line.length > 1 THEN
            writeln (substr (new_line, 1, new_line.length - 1))
         ELSE
            writeln;
      END {while};
   END {if};
END. {program combine}
