
{-----------------------------------------------------------------------------|
| DUPS.PAS  -  transfers only duplicate lines or line parts from input  |
|  |
| To be used with DCL Procedure PIPE.COM.                (Author: T.HALL)  |
|  |
|-----------------------------------------------------------------------------}

PROGRAM dups (input, output);

CONST string_length = 984; { Length chosen because of TPU }

TYPE  line_type = VARYING [string_length] OF char;

%INCLUDE 'parm.def'      { Allows to get next parameter with proc. NEXT_PARM }

VAR   line, parm, l_sub, s_sub, saved_string : line_type;
      start, lgth, s_lgth, l_lgth : integer;
      first_equal_line : boolean := true;

BEGIN {program dups}
   next_parm (parm);
   IF parm <> '' THEN
   BEGIN
      readv (parm, start);
      next_parm (parm);
      IF parm <> '' THEN
      BEGIN
         readv (parm, lgth);
         IF lgth = 0 THEN lgth := -1;
      END
      ELSE lgth := 0;
   END
   ELSE
   BEGIN
      start := 1;
      lgth := 0;
   END {if};
   IF lgth < 0 THEN
      writeln ('*** DUPS: Parameter "Length" must not be 0')
   ELSE
   BEGIN
      saved_string := '';
      WHILE NOT eof DO
      BEGIN
         readln (line);
         IF (lgth > line.length - start + 1) OR (lgth = 0) THEN
            l_lgth := line.length - start + 1
         ELSE 
            l_lgth := lgth;
         IF first_equal_line THEN
            IF (lgth > saved_string.length - start + 1) OR (lgth = 0) THEN
               s_lgth := saved_string.length - start + 1
            ELSE 
               s_lgth := lgth;
         IF line = '' THEN
            l_sub := ''
         ELSE
            l_sub := substr (line, start, l_lgth);
         IF first_equal_line THEN
            IF saved_string = '' THEN
               s_sub := ''
            ELSE
               s_sub := substr (saved_string, start, s_lgth);
         IF l_sub = s_sub THEN
            IF first_equal_line THEN
            BEGIN
               writeln (saved_string);
               writeln (line);
               first_equal_line := false;
            END
            ELSE
               writeln (line)
         ELSE 
         BEGIN                       
            saved_string := line;
            first_equal_line := true;
         END;
      END {while}                    
   END {if}                          
END. {program dups}
