! 
! MAKE - A Filter used with pipe to treat only the files
!        that are newer than files with equal name but different type.
!                                                            Author: T. Hall
!
!        Parameters:    p1  -  DCL-Command (Operation)
!                       p2  -  Files to be treated
!                       p3  -  Type of related files
!                       p4  -  Command qualifiers.
!
!        Example:  $ pipe  ls *.c | +make cc &LINE obj
!                    translates only these C-files being newer than the
!                    related Objectmodules.
!
$ file2 = f$parse(p2,,,"directory") + f$parse(p2,,,"name") -
               + "." + p3
$ if f$cvtime (f$file_attributes (p2, "rdt")) -
        .les. f$cvtime (f$file_attributes (file2, "rdt"))  -
  then exit
$ make_cmd = p1 + " " + p2 + " " + p4
$ write sys$output "$ ", make_cmd
$ 'make_cmd
