!----------------------------------------------------------------------
! PART.COM - this procedure uses PIPE.COM and the filter SPLIT        !
! to split a large (text) file into several parts each with the same  !
! number of records.                       (Author: Thomas Hall)      !
!                                                                     !
! Parameters: p1   file to be splitted (input file)                   !
!             p2   records of each outputfile                         !
!             p3   number of output files                             !
!                                                                     !
! The input file will not be changed or deleted.                      !
!----------------------------------------------------------------------
$ file_name = p1
$ records = p2
$ parts = p3
$ if p1 .eqs. "" then inqui/nop file_name "File to be splitted > "
$ if p2 .eqs. "" then inqui/nop records "Records for each part > "
$ if p3 .eqs. "" then inqui/nop parts "Number of parts > "
$ records = f$integer (records)
$ if records .le. 0 then goto invalid_records
$ parts = f$integer (parts)
$ if parts .le. 0 then goto invalid_parts
$ f_dir  = f$parse (file_name,,,"DIRECTORY")
$ f_name = f$parse (file_name,,,"NAME")
$ if f_name .eqs. "" then goto invalid_name
$! if f$type (pipe) .eqs. "" then @disk$us1:[hall.ut.pipe]pipe_login
$ i = 1
$ copy 'file_name' sys$scratch:rest0.dat
$loop:
$  s_file = f$fao ("!AS!AS.!2ZL_!2ZL", f_dir, f_name, i, parts)
$  modus = i - i / 2 * 2
$  modus1 = 1 - modus
$  input_file = "sys$scratch:rest"'modus1'".dat"
$  output_file = "sys$scratch:rest"'modus'".dat"
$  write sys$output "PIPE SPLIT ",records," ",s_file, -
     " <",input_file," >",output_file
$  pipe split 'records' 's_file' <'input_file' >'output_file'
$  i = i + 1
$  if i .lt. parts then goto loop
$ s_file = f$fao ("!AS!AS.!2ZL_!2ZL", f_dir, f_name, i, parts)
$ write sys$output "RENAME ",output_file," ", s_file
$ rename 'output_file' 's_file'
$ if parts .le. 2 then delete 'input_file';*
$ if parts .gt. 2 then delete 'input_file';*,'output_file';*
$ exit
$invalid_name:
$ write sys$error "File ", file_name, " not found, nothing splitted"
$ exit                                      
$invalid_records:
$ write sys$error "Invalid records specified"
$ exit                                      
$invalid_parts:
$ write sys$error "Invalid parts specified"
$ exit                                      
