$ SAVE_VERIFY='F$VERIFY(FORCE_VERIFY)
!
! PIPE.COM v3.8f - DATA PIPE SIMULATOR
!
!   usage: $ PIPE [-trace] [<infile] [command [args...]] [>outfile] [|...]
!			e.g.PIPE DIR [*...] SORT |DUPS >DUPLICATES.DIR
$!
$!
$! recent history:
$! 920503 frams added some stuff: gawk, sed, grep, perl etc.. !#
$! 910529 kenw	fix output redirection parser bug reported by Rao Akella
$! 901216 kenw	added Hall filters in preparation for distribution
$! 901010 kenw	V3.8: upgraded to VMS V5 DCL, optimized parsing, 
$!		changed debug/trace handling
$! 900408 kenw	3.7b: added ">>" append operator, fixed verify control
$! 900215 kenw	made "-DEBUG" a command line option, took ON/NOON out of 
$!		verified execution, added missing-arg check to parser
$! 900213 kenw	add time to temp filespec
$! 890501 kenw	fixed SYS$INPUT handling in shell mode
$! 890424 kenw	simplified parser, optimised
$! 890412 kenw	drop output channel opening; suggested by Brian Carcich
$!
$	ON ERROR     THEN GOTO FINISH
$	ON CONTROL_Y THEN GOTO FINISH
$!
$	DEASSIGN SYS$INPUT		! PREPARE FOR PIPE I/O
$	DEASSIGN SYS$OUTPUT
$!
$	TIME=F$CVTIME()-"-"-"-"-" "-":"-":"-"."
$	TMPFILE="SYS$SCRATCH:"+F$GETJPI("","PID")+TIME+".PIPE;"
$!
$	PIPE_VERIFY=SAVE_VERIFY.AND.(F$MODE().EQS."INTERACTIVE")
$					! "set verify" interactive only
$!
$! FILTER symbol definitions for PIPE.COM 
$! note: this isn't the best way, but it's the fastest without global symbols
$!
$	AF*TER	    :=@PIPE:AFTER
$	awk	    :=$pipe:gawk sys$input /com= !#
$	COL*UMNS    :=@PIPE:COLUMNS
$	COM*BINE    :=@PIPE:COMBINE
$	COU*NT	    :=@PIPE:COUNT
$	DI*RECT	    :=DIRECTORY/COLUMNS:1/NOHEADER/NOTRAILER
$	DUP*S	    :=@pipe:dups
$	ECHO	    :=write sys$output """
$	ELEM*ENT    :=@PIPE:ELEMENT
$!	EXTR*ACT    :=@PIPE:EXTRACT
$	ex*tract    :=$pipe:extract sys$input !#
$	f$ed	    :=@PIPE:EDIT !#
$	f$el*em	    :=@PIPE:EL2
$	f$ex*tr	    :=@PIPE:EXTRACT !#
$	FIL2DIR	    :=@PIPE:FIL2DIR
$	FIND	    :=SEARCH/WIN=0/NOHEA
$	catch	    :=SEARCH SYS$INPUT
$	ITEM	    :=@PIPE:ITEM
$!	JUST*IFY    :='mung PIPE:JUSTIFY
$	JUST*IFY    :=@PIPE:JUSTIF !#
$	LS	    :=@pipe:ls !#
$	lse	    :=@pipe:lse !#
$	MAKE	    :=@PIPE:MAKE
$	MORE	    :=@pipe:look !#
$	NOCTRL	    :=$PIPE:NOCTRL  
$	NODUP*S	    :=@pipe:nodups
$	NOEMPTY	    :=@PIPE:NOEMPTY
$	PARSE	    :=@PIPE:PARSE
$	PART	    :=@PIPE:PART
$	QUENAMES    :=@PIPE:QUENAMES
$	repl*ace    :=@PIPE:replace !#
$	REPO*RT	    :=@PIPE:REPORT
$!	SEa*rch	    :=search sys$input
$	SED	    :=$PIPE:gnused  !#
$	SKIP	    :=@PIPE:SKIP
$	SORT	    :=SORT SYS$INPUT SYS$OUTPUT
$	SPLIT	    :=@PIPE:SPLIT
$!	SQU*ISH	    :='MUNG PIPE:SQUISH
$!	TAB*IFY	    :='MUNG PIPE:TABIFY
$	TAIL	    :=$PIPE:TAIL
$	TAL*LY	    :=@PIPE:TALLY
$	TEE	    :=@PIPE:TEE
$	TOT*AL	    :=@PIPE:TOTAL
$!	TRIM	    :='mung TRIM
$	tp	    :=type/page sys$input !#
$	uud*ecode   :=$pipe:uudecode sys$input !#
$	uue*ncode   :=$pipe:uuencode sys$input !#
$	UNIQ	    :='NODUPS
$	WIDE	    :=$PIPE:WIDE
$	WC	    :=@PIPE:WC
$	wild	    :=$PIPE:Wild !#
$!
$	FALSE = 0
$	TRUE  = .NOT. FALSE
$!
$!
$!Command Parsing
$!===============
$!
$	WCMD=F$EDIT(P1+" "+P2+" "+P3+" "+P4+" "+P5+" "+P6+" "+P7+" "+P8,-
		"COMPRESS,TRIM")
$	INTERACTIVE=WCMD.EQS.""
$!
$GET_WCMD:
$	IF INTERACTIVE
$	THEN
$		INQUIRE/NOPUNCT WCMD "| "
$		WCMD=F$EDIT(WCMD,"COMPRESS,TRIM")
$	ENDIF
$	IF WCMD.EQS."" THEN GOTO EXIT
$!
$	PIPE_TRACE=F$LOCATE(F$EDIT(F$ELEMENT(0," ",WCMD),-
		"UPCASE"),"-TRACE").EQ.0
$	IF PIPE_TRACE
$	THEN
$		WCMD=F$EXTRACT(F$LOCATE(" ",WCMD),999,WCMD)
$		DBO := WRITE SYS$COMMAND
$	ELSE
$		DBO = "!"
$	ENDIF
$!
$quot: pos=f$loc("#",wcmd) !#
$if pos .lt. f$len(wcmd)
$  then
$  wcmd=f$extract(0,pos,wcmd)+""""+f$extract(pos+1,999,wcmd)
$  goto quot
$endif
$
$	R=0	!parameter number
$	P=""	!current parameter
$	PIPEFILE=TMPFILE
$!
$	CMD=""
$	INPT=""
$	OUPT=""
$	PUSHING=FALSE
$	COND_PUSH=FALSE
$	APND=FALSE
$!
$!parser states
$	OPS=";|<>\?+"
$	NTL=F$LENGTH(OPS)
$	STATE=NTL
$!
$	dbo "-pre-parse, WCMD = [",WCMD,"]"
$!
$PARSE:
$	IF P.EQS ""	 	!handle unused "args" (eg on |...)
$	THEN
$		P=F$ELEMENT(R," ",WCMD)
$		dbo "-parse, P=[",P,"]	",f$time()
$		IF P.EQS." "	THEN GOTO DONE_PARSE
$		R=R+1
$		IF P.EQS.""	THEN GOTO T_'NTL	!handle quoted spaces
$		IF STATE.NE.NTL THEN GOTO T_'STATE
$				! previous operater was missing this arg
$	ENDIF
$
$	STATE=F$LOCATE(F$EXTRACT(0,1,P),OPS)		!find 1-char operators
$	IF STATE.NE.NTL THEN P=F$EXTRACT(1,999,P)	!strip the operator
$	GOTO T_'STATE
$!
$T_0:	!multiple command w/o piping - ;
$	GOSUB EXECUTE
$	GOTO NEXT_CMD
$!
$T_1:	!pipe redirect - |
$	IF OUPT.EQS."" THEN OUPT=PIPEFILE !allow ">" to override "|"
$	GOSUB EXECUTE
$	INPT=PIPEFILE
$	PIPEFILE=TMPFILE
$!
$NEXT_CMD:	!handle end of a command section
$	OUPT=""
$	CMD=""
$	PUSHING=FALSE
$	COND_PUSH= FALSE
$	APND=FALSE
$	STATE=NTL	!pass any argument (P) back to neutral parser
$	GOTO PARSE			!***
$!
$T_2:	!input redirection - <
$	INPT=P
$	IF P.EQS."" THEN GOTO PARSE	!handle missing args
$	GOTO CLEAR_STATE
$!
$T3_0:	!output redirection with append - >>
$	APND=TRUE
$!
$T_3:	!output redirection - > and >>
$	SSTATE=F$LOCATE(F$EXTRACT(0,1,P+" "),">")
$	IF SSTATE.NE.1 THEN P=F$EXTRACT(1,999,P)
$	GOTO T3_'SSTATE
$!
$T3_1:	!simple output redir - >
$	OUPT=P
$	PIPEFILE="NL:"
$	IF P.EQS."" THEN GOTO PARSE	!handle missing args
$	GOTO CLEAR_STATE
$!
$T_4:	!escape: neutral - \
$	P=F$EXTRACT(1,999,P)
$	GOTO T_'NTL
$!
$T_5:	!conditional pipe - ?
$	COND_PUSH=TRUE
$!
$T_6:	!data as argument - +
$	PUSHING=TRUE 
$!
$T_7:	!neutral/command - no operator
$	CMD=CMD+" "+P
$!
$CLEAR_STATE:
$	P=""
$	STATE=NTL	!input operator/state is satisfied
$	GOTO PARSE
$!
$DONE_PARSE:
$	CMD=CMD+" "+P
$	GOSUB EXECUTE
$	GOTO FINISH
$!
$!
$!Execute the Command Line
$!========================
$!
$EXECUTE:
$	dbo "-execute, cmd=[",cmd,"], pushing=[",pushing,"]	",f$time()
$	OCMD=CMD	! Save original command to allow tacking on data
$			! when working in data-as-args mode
$!
$! open channels
$!
$	IF "''INPT'".NES.""
$	THEN
$	    OPEN PIPE_INPUT 'INPT
$	    IF.NOT.pushing THEN ASSIGN/NOLOG PIPE_INPUT SYS$INPUT
$	ENDIF
$!
$	IF "''OUPT'".NES.""
$	THEN
$	    IF APND
$	    THEN
$		OPEN/read/write PIPE_OUTPUT 'oupt
$		close PIPE_OUTPUT	! create outfile if necessary
$		OPEN/APPEND PIPE_OUTPUT 'oupt
$	    ELSE
$	    	ASSIGN/NOLOG 'oupt PIPE_OUTPUT
$	    ENDIF
$	    ASSIGN/NOLOG PIPE_OUTPUT SYS$OUTPUT
$	ENDIF
$!
$    PUSH_LOOP:
$	IF pushing	! if "+" or "?" operator, read data into command
$	THEN
$		READ/END=CLOSE PIPE_INPUT LINE
$		dbo "-push, line=[",line,"]	",f$time()
$		CMD=OCMD
$		X=F$LOCATE("&LINE",CMD)
$		IF X.GE.F$LENGTH(CMD)		! tack data on end??
$		THEN
$			CMD=CMD+" "+LINE
$		ELSE
$		    IN_LINE:			! else substitute in-line
$			CMD=F$EXTRACT(0,X,CMD)+LINE+F$EXTRACT(X+5,999,CMD)
$			XX=F$LOCATE("&LINE",CMD)
$			IF XX.LT.F$LENGTH(CMD).AND.XX.GT.X+F$LENGTH(LINE)
$			THEN			! trap resursive substitutions
$				X=XX
$				GOTO IN_LINE
$			ENDIF
$		ENDIF
$		dbo "-in_line, cmd=[",cmd,"]	",f$time()
$!
$		IF COND_PUSH
$		THEN
$			READ SYS$COMMAND DOIT/ERROR=FINISH/END=FINISH -
				/PROMPT="$''CMD' [Y]? "
$			DOIT=F$EDIT(DOIT,"UPCASE,TRIM")
$			IF DOIT.EQS."ALL"
$			THEN
$			    COND_PUSH=FALSE
$			ELSE
$			    IF (.NOT.DOIT).AND.(DOIT.NES."") THEN GOTO PUSH_LOOP
$			ENDIF
$		ENDIF
$	ENDIF
$
$! do the command
$DOCMD:
$	SET NOON
$	PIPE_JUNK=F$VERIFY(PIPE_VERIFY)	! restore external verify
$ 'CMD
$	!'F$VERIFY(FORCE_VERIFY)		! restore internal verify
$	SET ON
$
$	IF pushing THEN GOTO PUSH_LOOP	!if "pushing", repeat command until 
$					!there is no more data in the pipe
$!
$! close channels and clean up
$!
$CLOSE:
$	IF "''INPT'".NES.""
$	THEN
$	    IF.NOT.pushing THEN DEASSIGN SYS$INPUT
$	    CLOSE PIPE_INPUT
$	    IF F$SEARCH("PIPE_INPUT").NES."" THEN DELETE PIPE_INPUT
$	ENDIF
$!
$	IF "''OUPT'".NES.""
$	THEN
$	    DEASSIGN SYS$OUTPUT
$	    IF APND
$	    THEN
$		CLOSE PIPE_OUTPUT
$	    ELSE
$		DEASSIGN PIPE_OUTPUT
$	    ENDIF
$	ENDIF
$!
$ RETURN
$!
$
$!
$! Cleanup and exit
$!=================
$!
$FINISH:
$	dbo "-finish	",f$time()
$	@NL:				! force image exit
$	DEASSIGN SYS$INPUT
$	DEASSIGN SYS$OUTPUT
$	IF F$LOGICAL("PIPE_INPUT") .NES."" THEN CLOSE PIPE_INPUT
$	IF F$LOGICAL("PIPE_OUTPUT").NES.""
$	THEN
$	    IF APND
$	    THEN
$		CLOSE PIPE_OUTPUT
$	    ELSE
$		DEASSIGN pipe_OUTPUT
$	    ENDIF
$	ENDIF
$!
$	IF INTERACTIVE THEN GOTO GET_WCMD
$!
$EXIT:
$	IF F$SEARCH(TMPFILE).NES."" THEN DELETE 'TMPFILE'*
$!
$	EXIT $STATUS+0*F$VERIFY(SAVE_VERIFY)	! RESTORE VERIFY
$!
$!	setup definitions:
$!		symbol PIPE for command execution
$!		logical PIPE for package location (default: PIPE.COM location)
$!
$!	there are 3 major sections:
$!		initialization - define local symbols
$!		parsing - take a command from SYS$INPUT, parse it
$!		execution - process the command
$!
$!	bugs:
$!		- there may be some problems with input by command files
$!		with redirected channels under wierd circumstances; caused 
$!		by DCL switching source of input at EOF.
$!		- top-level I/O redirection will not work properly within 
$!		command files.  DCL lies about filespecs and doesn't stack 
$!		them.
$!		- VERIFY handling is tricky, since there is no DCL equivalent
$!		to the VMS DEBUGGER's input/output redirection logicals. 
$!		- control-Y handling awkward with called DCL.
