{ Author: Ulli 'Framstag' Horlacher , framstag@rz.uni-ulm.de , Nov 1991 }

[ inherit('sys$library:pascal$lib_routines','sys$library:pascal$str_routines'),
  check(all) ]

program UUFIX (input,output);
      
type  string80 = varying [80] of char;

var   inf,outf,err                 : text;
      error,code_start             : boolean := false;
      i,n,max_lines,max_parts      : integer := 0;
      subject_line                 : array [1..100] of integer := zero;
      zeile                        : array [1..50000] of string80;
      parameter,read_from,write_to,line  : string80;
     

function get_part_number (direction : integer) : integer;

var  ir,il,dlm,part   : integer;
     numeric          : boolean;
     subj             : string80;
     z                : packed array [1..1] of char;

begin
  repeat
    numeric:=true;
    dlm:=index(subj,'/');
    if dlm=0 then dlm:=index(subj,' OF ')+direction+1;
    if dlm=0 then dlm:=index(subj,'OF')+direction+1;
    ir:=dlm;
    repeat
      ir:=ir+direction;
      z:=substr(subj,ir,1);
      numeric:=numeric and (z::char in ['0'..'9',' ']);
    until (z<>' ');
    if not numeric then subj:=substr(subj,dlm+1,length(subj)-dlm);
  until numeric;
  il:=ir;
  repeat
    il:=il+direction;
    z:=(substr(subj+'#',il,1));
  until not(z::char in ['0'..'9']);
  if direction = -1 then readv(substr(subj,il+1,ir-il),part);
  if direction = +1 then readv(substr(subj,ir,il-ir),part);
  writeln(direction,part);
  get_part_number:=part;
end;


begin

  lib$get_foreign(%descr parameter);
  if parameter='' then
    begin
      writeln;
      writeln('UUFIX restores uuencoded files with wrong order or which');
      writeln('do include mail or news-headers.');
      writeln('Just save all parts in one single file.');
      writeln;
      write('read from: ');
      readln(read_from);
      write('write to: ');
      readln(write_to); 
    end
  else
    begin
      i:=index(parameter,' ');
      if i=0 then
        begin
          read_from:=parameter;
          write_to:='sys$output';
        end
      else
        begin
          read_from:=substr(parameter,1,i);
          write_to:=substr(parameter,i,length(parameter)-i+1);
        end;
    end;

  open(inf,read_from,history:=old);
  reset(inf);
  repeat
    max_lines:=max_lines+1;
    readln(inf,line);
    str$upcase(%descr subj,%descr line);
    if (substr(line+'     ',1,5)='SUBJ:') or
      (substr(line+'        ',1,8)='SUBJECT:') then
      if index(line,'/')+index(line,'OF')=0 then begin
        subject_line[1]:=max_lines;
        max_parts:=1;
	end
      else
        subject_line[get_part_number(-1)]:=max_lines;
      if max_parts=0 then max_parts:=get_part_number(+1);
    end;
    zeile[max_lines]:=line;
  until eof(inf);
  close (inf);

  open(err,'sys$error',history:=new);
  rewrite(err);

  for i:=1 to max_parts do
    if subject_line[i]=0 then
      begin
        error:=true;
        writeln(err,'Error:  missing part',i:3,'  of',max_parts:3);
      end;  

  if not(error) then
    begin
      open (outf,write_to,history:=new);
      rewrite(outf);
      writeln('max_parts:',max_parts);
      for n:=1 to max_parts do
        begin
        i:=subject_line[n];
        repeat
	  i:=i+1;
	  code_start:=substr(zeile[i+1]+' ',1,1)+substr(zeile[i]+' ',1,1)+
                      substr(zeile[i+2]+' ',1,1)='MMM';
        until code_start;
        if n=1 then writeln(outf,zeile[i-1]);
        repeat
          writeln(outf,zeile[i]);
          i:=i+1;
        until substr(zeile[i]+' ',1,1)<>'M';
      end;
      writeln(outf,zeile[i]);
      writeln(outf,zeile[i+1]);
      writeln(outf,zeile[i+2]);
    end
end.
